define([
    "dijit/_Container",
    "dijit/form/_FormMixin",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event"
], function(_Container, _FormMixin, array, declare, event) {
    return declare([_Container,_FormMixin],{
        name: "",
        value: null,
        disabled: false,
        readOnly: false,
        postCreate: function() {
            this.inherited(arguments);
            if ( this.domNode.tagName.toLowerCase() !== "form" ) {
                console.warn("Not scoping a _ComplexValueMixin in a form element can cause name clashes. E.g. radio buttons might stop working correctly. It is recommended to use <form> as the root element in your template for "+this.declaredClass+".");
            }
        },
        _setDisabledAttr: function(value) {
            this._set("disabled", value);
            array.forEach(this._getDescendantFormWidgets(), function(child){
                child.set("disabled", value);
            });
        },
        _setReadOnlyAttr: function(value) {
            this._set("readOnly", value);
            array.forEach(this._getDescendantFormWidgets(), function(child){
                child.set("readOnly", value);
            });
        },
        focus: function() {
            var children = this._getDescendantFormWidgets();
            if ( children.length > 0 ) {
                children[0].focus();
            }
        },
        onSubmit: function(e) {
            // since this widget is used to create more complex
            // widgets within other forms, the onSubmit must either be
            // ignored or propagated, but not handled here.
            if ( e ) { event.stop(e); }
            return false;
        },
        _onSubmit: function(e) {
            // since this widget is used to create more complex
            // widgets within other forms, the onSubmit must either be
            // ignored or propagated, but not handled here.
            if ( e ) { event.stop(e); }
            return false;
        }
    });
});
